\section{Load/Store unit} \label{sec_ldst}

The \texttt{Load/Store} unit handles all data memory operations featuring a private L1 \textit{n}-way set-associative cache allocated at the core level. All cache parameters are configurable, such as number of sets and number of ways. It implements a non-blocking miss mechanism. When a memory miss occurs, the core can still execute instruction on different data, while the Load/Store unit is retrieving the data from the memory hierarchy. %The Load Store Unit does not store specific coherence protocol information (stable states), but it stores privileges for all cached addresses. Each cache line has two privileges: can read and can write. Those privileges determine cache misses/hits and are updated by the Cache Controller. 
It interfaces the Operand fetch and Writeback stages on the core side, dually on the bus side it communicates with the cache controller which updates information (namely tags and privileges) and data, as shown in Figure \ref{fig:ldst}. Moreover, such a module sends a signal to the instruction buffer unit which has the purpose of stopping a thread in case of miss. Load/Store unit does not store any information about the coherence protocol used, although it keeps track of information regarding privileges of cached blocks. Each cache line stored, in fact, is associated to two privileges: \textit{can read} and \textit{can write} that are used to determine cache miss/hit and are updated by the Cache Controller. Finally, it should be noted that this unit does not manage addresses that refer to the IO address space: whenever an issued request belonging to the non-coherent memory space is directly forwarded to the Cache Controller which will handle bypassing the coherence protocol, sending the request to the memory controller and report the data back to the third stage.

\begin{figure}[t]
	\centering
	\includegraphics[width=1\textwidth]{Chapters/Cohe/figures/LDST.eps}
	\caption{Load/store unit detailed view.}
	\label{fig:ldst}
\end{figure}

L1 cache design has been driven by the following assumptions:

\begin{enumerate}
	\item The module has to be protocol independent. Protocol details are handled by the Cache Controller. The Load/Store unit associates privileges with each set line, that abstract the coherence protocol. Each set line can be in invalid, read only mode, write only mode, or read and write mode.
	\item The module has to provide enough parallelism to support the GPU-like core memory access rate. If a thread raises a cache miss, the thread is not suspended, a second missing request will block it until all pending requests are fulfilled by the Cache Controller.
	\item Different memory requests from the same thread are scheduled and served in order.
\end{enumerate}

This unit is divided into three stages. The first performs a phase of decoding and verification of the incoming memory request (to understand if it is a word, half word or byte access), it also checks the address alignment. Such a control is done based on memory access types (namely scalar or vectorial) on byte, half-word and word. On the other hand, if an instruction requires an improper address, this stage asserts a misaligned signals, which forces the core to discard this request and raises a trap. Valid requests from the Operand Fetch are queued in FIFOs here allocated, and presented as pending instructions to the second stage. The first stage provides also recycle buffers besides those FIFOs. If a cache miss occurs in the 3rd stage, the scheduled request is forwarded back to these buffers. Pending requests from recycle buffers compete with the normal issued load/store instruction to be re-executed. Recycled instructions have the higher priority compared to other pending operations. Such high-priority buffers are necessary to satisfy the third assumption. Finally, a pending instruction for each thread is forwarded in parallel to the next stage. When the second stage accepts an instruction from the i-th thread, it asserts the i-th bit of the dequeuing mask. The i-th bit of this mask is connected to the dequeue port of the i-th FIFO, and the instruction is popped from its queue.

The second stage arbiters the FIFOs in the first stage, also allocates L1 cache tag and privilege information. This stage receives as many parallel requests from the core as the number of threads. A pending request is selected from the pool of pending requests from the previous stage. A thread is chosen by a round-robin arbiter, although recycled instructions have the highest priority.
When a memory request is scheduled, this stage forwards to the next stage the scheduled request, tag and privileges relative to the requesting address, fetching these information from the tag and info caches. Tags and information caches are organized as a SRAMs equipped with $2$ read ports and $1$ write port. A second reading port is provided in order to facilitate \texttt{Cache Controller} snooping operation over cache tags and information. The implemented SRAMs provides a read-first mechanism, in the worst scenario the Cache Controller updates tag or privileges of the same address that is requested by an already scheduled operation. With a read-first policy, the operation retrieves the right information. Furthermore, whenever a cache miss occurs, this stage stalls the corresponding thread until the data is retrieved back from the main memory.
This stage does not updates the cache information itself, this is up to the Cache Controller which has a preferential port and through this it sends data and commands to the second stage. 

The Cache Controller sends different commands to the Load/Store unit and they are handled in this stage:

\begin{enumerate}
	\item In case of \textbf{CC\_INSTRUCTION}, the stage 2 allocates in cache a new block line, updating  information with new privileges, dirty bytes mask, and tags, while data are propagated to the 3rd stage where the data cache is physically allocated.
	\item In case of \textbf{CC\_UPDATE\_INFO} from the cache controller, stage 2 updates an existing cache set in a give way. In such a case, only information are updated, nothing is propagated to the 3rd stage, since it is not necessary to update the data cache. The privileges and the cache tag are updated with the values provided by the cache controller. It also indicates which way must be updated being responsible for the pseudo-LRU.
	\item In case of \textbf{CC\_UPDATE\_INFO\_DATA} from the cache controller, stage 2 receives an update command for an existing set, but in such cases data are also updated. Stage 2 propagates to the 3rd stage the request address, its information (privileges and tags), and data provided by the cache controller.
	\item  Finally, in case of \textbf{CC\_EVICT} command from the CC, stage 2 notifies to the data cache that the data must be replaced, and an eviction operation take place. Block information, along with data and tag, are propagated from the Load/store unit to the Cache Controller, which will handles the placing back into the main memory. 
\end{enumerate}

The third stage detects if a cache miss or hit occurs, also allocates the data cache, which is a SRAM with $2$ read ports and $1$ write port. When an instruction is issued, this stage checks privileges and tags and asserts the miss output bit consequently. If a miss occurs the instruction is forwarded back to the recycle buffer in the first stage and this module dispatches a miss request to the Cache Controller. %From this moment onward, the Cache Controller manages the data cache as in the previous stage, and has a privileged snoop port on it.
%This stage receives input instructions, data update and replacement requests. Before managing logic to generate the output it is necessary to understand the type of request received (instruction, data update, replacement). Moreover, in case of instruction the control logic have to check if there is a hit or a miss and if there is a \texttt{load\_miss} or \texttt{store\_miss} (that occur if we do not have the necessary privileges). 
%A cache hit occurs, if the requesting block has the right privileges (read or write), and if its address tag is stored in the corresponding set in tag cache. %Then it must be verified if we have permissions to perform operations on the block for which there was a hit. 
%E.g., if there is a hit for that address and the request is a store, the requested set have write permissions for that block otherwise miss occurs. Therefore, in case of store hit it saves data in the data cache (and no request is forwarded to the Cache Controller). 
In case of load hit the output valid signal is asserted, and data is forwarded to the Writeback module of the core, along with the instruction that originated the memory request. The Writeback strips the instruction using it to retrieve the destination register. In case of store hit, the load/store unit have the \textit{can write} permission on the block address, the third stage updates data cache and no requests are forwarded to the Cache Controller. In case of store/load miss the output miss signal is asserted, the request is both recycled and propagated to the Cache Controller. Furthermore, in such cases the requesting thread is stalled, saving it ID in a sleeping queue, which tracks inactive threads. %In case of update operations, the data cache line identified by the signals pair \texttt{ldst2\_address.index} and \texttt{ldst2\_update\_way} is updated with the new data \texttt{ldst2\_store\_value} coming from previous stage.

Finally, during eviction or replacement operations, the set is updated with the new value, and its old content is sent to the Cache Controller, which handles the data writing back. %In detail, are sent to the controller cache: the old address on \texttt{ldst3\_address}; the old cache line contents on \texttt{ldst3\_cache\_line} and \texttt{ldst3\_evict} is asserted.

%Note that, there is a second read port for the data cache that is used by the cache for snoop requests (that is, the read requests that are used by the controller cache to read the data, is a sort of fast lane). This port is \textbf{WRITE FIRST} so the cache controller receives the latest version of the data even when we are doing a store operation on that cache line.